# gdcm::Attribute< Group, Element, TVR, VM::VM1_n > Class Template Reference

`#include <gdcmAttribute.h>`

Inheritance diagram for gdcm::Attribute< Group, Element, TVR, VM::VM1_n >:
[legend]

List of all members.

## Public Types

typedef VRToType< TVR >::Type | ArrayType

## Public Member Functions

| Attribute ()
| ~Attribute ()
| GDCM_STATIC_ASSERT ((VM::VM1_n &(VM::VMType)(TagToType< Group, Element >::VMType)))
| GDCM_STATIC_ASSERT (((VR::VRType) TVR &(VR::VRType)(TagToType< Group, Element >::VRType)))
| GDCM_STATIC_ASSERT (((((VR::VRType) TVR &VR::VR_VM1)&&((VM::VMType) TagToType< Group, Element >::VMType==VM::VM1))||!((VR::VRType) TVR &VR::VR_VM1)))
DataElement | GetAsDataElement () const
unsigned int | GetNumberOfValues () const
ArrayType & | GetValue (unsigned int idx=0)
ArrayType const & | GetValue (unsigned int idx=0) const
const ArrayType * | GetValues () const
ArrayType & | operator[] (unsigned int idx)
ArrayType const & | operator[] (unsigned int idx) const
void | Print (std::ostream &os) const
void | SetFromDataElement (DataElement const &de)
void | SetNumberOfValues (unsigned int numel)
void | SetValue (ArrayType v)
void | SetValue (unsigned int idx, ArrayType v)
void | SetValues (const ArrayType *array, unsigned int numel, bool own=false)

## Static Public Member Functions

static VM | GetDictVM ()
static VR | GetDictVR ()
static Tag | GetTag ()
static VM | GetVM ()
static VR | GetVR ()

## Protected Member Functions

void | SetByteValue (const ByteValue *bv)

### template<uint16_t Group, uint16_t Element, int TVR>
class gdcm::Attribute< Group, Element, TVR, VM::VM1_n >

## Member Typedef Documentation

template<uint16_t Group, uint16_t Element, int TVR>

typedef VRToType<TVR>::Type gdcm::Attribute< Group, Element, TVR, VM::VM1_n >::ArrayType

## Constructor & Destructor Documentation

template<uint16_t Group, uint16_t Element, int TVR>

gdcm::Attribute< Group, Element, TVR, VM::VM1_n >::Attribute | ( | ) | `[inline, explicit]`

References gdcm::Attribute< Group, Element, TVR, TVM >::Internal.

template<uint16_t Group, uint16_t Element, int TVR>

gdcm::Attribute< Group, Element, TVR, VM::VM1_n >::~Attribute | ( | ) | `[inline]`

References gdcm::Attribute< Group, Element, TVR, TVM >::Internal.

## Member Function Documentation

template<uint16_t Group, uint16_t Element, int TVR>

gdcm::Attribute< Group, Element, TVR, VM::VM1_n >::GDCM_STATIC_ASSERT | ( | ((VR::VRType) TVR &(VR::VRType)(TagToType< Group, Element >::VRType)) | ) |

template<uint16_t Group, uint16_t Element, int TVR>

gdcm::Attribute< Group, Element, TVR, VM::VM1_n >::GDCM_STATIC_ASSERT | ( | (VM::VM1_n &(VM::VMType)(TagToType< Group, Element >::VMType)) | ) |

template<uint16_t Group, uint16_t Element, int TVR>

gdcm::Attribute< Group, Element, TVR, VM::VM1_n >::GDCM_STATIC_ASSERT | ( | ((((VR::VRType) TVR &VR::VR_VM1)&&((VM::VMType) TagToType< Group, Element >::VMType==VM::VM1))||!((VR::VRType) TVR &VR::VR_VM1)) | ) |

template<uint16_t Group, uint16_t Element, int TVR>

DataElement gdcm::Attribute< Group, Element, TVR, VM::VM1_n >::GetAsDataElement | ( | ) | const`[inline]`

References gdcm::Attribute< Group, Element, TVR, TVM >::GetNumberOfValues(), gdcm::Attribute< Group, Element, TVR, TVM >::GetTag(), gdcm::DataElement::GetVR(), gdcm::Attribute< Group, Element, TVR, TVM >::GetVR(), gdcm::Attribute< Group, Element, TVR, TVM >::Internal, gdcm::DataElement::SetByteValue(), gdcm::DataElement::SetVR(), gdcm::VR::SQ, gdcm::VR::UI, and gdcm::VR::VRASCII.

template<uint16_t Group, uint16_t Element, int TVR>

static VM gdcm::Attribute< Group, Element, TVR, VM::VM1_n >::GetDictVM | ( | ) | `[inline, static]`

References gdcm::Attribute< Group, Element, TVR, TVM >::GetVM().

template<uint16_t Group, uint16_t Element, int TVR>

static VR gdcm::Attribute< Group, Element, TVR, VM::VM1_n >::GetDictVR | ( | ) | `[inline, static]`

template<uint16_t Group, uint16_t Element, int TVR>

unsigned int gdcm::Attribute< Group, Element, TVR, VM::VM1_n >::GetNumberOfValues | ( | ) | const`[inline]`

template<uint16_t Group, uint16_t Element, int TVR>

static Tag gdcm::Attribute< Group, Element, TVR, VM::VM1_n >::GetTag | ( | ) | `[inline, static]`

template<uint16_t Group, uint16_t Element, int TVR>

ArrayType& gdcm::Attribute< Group, Element, TVR, VM::VM1_n >::GetValue | ( | unsigned int | idx = `0` ) | `[inline]`

References gdcm::Attribute< Group, Element, TVR, TVM >::GetNumberOfValues(), and gdcm::Attribute< Group, Element, TVR, TVM >::Internal.

template<uint16_t Group, uint16_t Element, int TVR>

ArrayType const& gdcm::Attribute< Group, Element, TVR, VM::VM1_n >::GetValue | ( | unsigned int | idx = `0` ) | const`[inline]`

References gdcm::Attribute< Group, Element, TVR, TVM >::GetNumberOfValues(), and gdcm::Attribute< Group, Element, TVR, TVM >::Internal.

template<uint16_t Group, uint16_t Element, int TVR>

const ArrayType* gdcm::Attribute< Group, Element, TVR, VM::VM1_n >::GetValues | ( | ) | const`[inline]`

References gdcm::Attribute< Group, Element, TVR, TVM >::Internal.

template<uint16_t Group, uint16_t Element, int TVR>

static VM gdcm::Attribute< Group, Element, TVR, VM::VM1_n >::GetVM | ( | ) | `[inline, static]`

Reimplemented in gdcm::Attribute< Group, Element, TVR, VM::VM2_2n >, gdcm::Attribute< Group, Element, TVR, VM::VM3_n >, and gdcm::Attribute< Group, Element, TVR, VM::VM3_3n >.

References gdcm::VM::VM1_n.

template<uint16_t Group, uint16_t Element, int TVR>

static VR gdcm::Attribute< Group, Element, TVR, VM::VM1_n >::GetVR | ( | ) | `[inline, static]`

template<uint16_t Group, uint16_t Element, int TVR>

ArrayType const& gdcm::Attribute< Group, Element, TVR, VM::VM1_n >::operator[] | ( | unsigned int | idx ) | const`[inline]`

References gdcm::Attribute< Group, Element, TVR, TVM >::GetValue().

template<uint16_t Group, uint16_t Element, int TVR>

ArrayType& gdcm::Attribute< Group, Element, TVR, VM::VM1_n >::operator[] | ( | unsigned int | idx ) | `[inline]`

References gdcm::Attribute< Group, Element, TVR, TVM >::GetValue().

template<uint16_t Group, uint16_t Element, int TVR>

void gdcm::Attribute< Group, Element, TVR, VM::VM1_n >::Print | ( | std::ostream & | os ) | const`[inline]`

References gdcm::Attribute< Group, Element, TVR, TVM >::GetNumberOfValues(), gdcm::Attribute< Group, Element, TVR, TVM >::GetTag(), gdcm::Attribute< Group, Element, TVR, TVM >::GetVM(), gdcm::Attribute< Group, Element, TVR, TVM >::GetVR(), and gdcm::Attribute< Group, Element, TVR, TVM >::Internal.

template<uint16_t Group, uint16_t Element, int TVR>

void gdcm::Attribute< Group, Element, TVR, VM::VM1_n >::SetByteValue | ( | const ByteValue * | bv ) | `[inline, protected]`

References gdcm::ByteValue::GetLength(), gdcm::ByteValue::GetPointer(), and gdcm::Attribute< Group, Element, TVR, TVM >::SetValues().

template<uint16_t Group, uint16_t Element, int TVR>

void gdcm::Attribute< Group, Element, TVR, VM::VM1_n >::SetFromDataElement | ( | DataElement const & | de ) | `[inline]`

References gdcm::DataElement::GetByteValue(), gdcm::Tag::GetGroup(), gdcm::DataElement::GetTag(), gdcm::Attribute< Group, Element, TVR, TVM >::GetTag(), gdcm::DataElement::GetVR(), gdcm::Attribute< Group, Element, TVR, TVM >::GetVR(), gdcm::DataElement::IsEmpty(), and gdcm::Attribute< Group, Element, TVR, TVM >::SetByteValue().

template<uint16_t Group, uint16_t Element, int TVR>

void gdcm::Attribute< Group, Element, TVR, VM::VM1_n >::SetNumberOfValues | ( | unsigned int | numel ) | `[inline]`

References gdcm::Attribute< Group, Element, TVR, TVM >::SetValues().

template<uint16_t Group, uint16_t Element, int TVR>

void gdcm::Attribute< Group, Element, TVR, VM::VM1_n >::SetValue | ( | unsigned int | idx,
|  | ArrayType | v
| ) |  | `[inline]`

References gdcm::Attribute< Group, Element, TVR, TVM >::GetNumberOfValues(), and gdcm::Attribute< Group, Element, TVR, TVM >::Internal.

template<uint16_t Group, uint16_t Element, int TVR>

void gdcm::Attribute< Group, Element, TVR, VM::VM1_n >::SetValue | ( | ArrayType | v ) | `[inline]`

References SetValue().

Referenced by SetValue().

template<uint16_t Group, uint16_t Element, int TVR>

void gdcm::Attribute< Group, Element, TVR, VM::VM1_n >::SetValues | ( | const ArrayType * | array,
|  | unsigned int | numel,
|  | bool | own = `false`
| ) |  | `[inline]`

References gdcm::Attribute< Group, Element, TVR, TVM >::GetNumberOfValues(), and gdcm::Attribute< Group, Element, TVR, TVM >::Internal.

The documentation for this class was generated from the following file:

- gdcmAttribute.h